using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

namespace CN.Teddy.AjaxHelper
{
	/// <summary>
	/// Summary description for RemoteScript.
	/// </summary>
	public class RemoteScript : System.Web.UI.Page
	{
		private void Page_Load(object sender, System.EventArgs e)
		{
			Response.ContentType = "text/javascript";

			string output = Request.QueryString["output"];
			string callback = Request.QueryString["callback"];
			string ajaxTemplate = Request.QueryString["AjaxTemplate"];

			if (ajaxTemplate != null)
			{
				try
				{
					string content = null;

					System.Net.WebClient client = new System.Net.WebClient ();
					client.Headers.Add("User-Agent", "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; .NET CLR 1.1.4322)");
					string ajaxPath = string.Format("http://{1}:{2}{3}Ajax.aspx?{0}", Request.ServerVariables["QUERY_STRING"], Request.ServerVariables["SERVER_NAME"], Request.ServerVariables["SERVER_PORT"], Request.ServerVariables["SCRIPT_NAME"].ToLower().Replace("remotescript.aspx", ""));
					System.IO.StreamReader sr = new System.IO.StreamReader(client.OpenRead(ajaxPath), System.Text.Encoding.UTF8);
					content = sr.ReadToEnd().Trim();
					sr.Close();

					//format content
					string prefix = "<!--AjaxContent-->";
					content = content.Substring(content.IndexOf(prefix, 0) + prefix.Length).Trim();
					content = content.Substring(0, content.Length - 7);

					//return script
					string script = "";
					if (output != null && output.Length > 0)
					{
						script += string.Format("if ($('{0}') != null) $('{0}').innerHTML = '{1}';", output, ToJavaScriptString(content));
					}
					if (callback != null && callback.Length > 0)
					{
						script += string.Format(" if ({0}) {0}('{1}');", callback, ToJavaScriptString(content));
					}
					Response.Write(script);
				}
				catch
				{
				}
			}
		}

		public static string ToJavaScriptString(string str)
		{
			return str.Replace("\n", "").Replace("\r", "").Replace("\\", "\\\\").Replace("'", "\\'").Replace("\"", "\\\"").Replace("/", "\\/");
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.Load += new System.EventHandler(this.Page_Load);
		}
		#endregion
	}
}
